// Assign variables to the player acoording to his side.
// Then add respawn and publicvariable eventhandlers that handle the moving, messaging and gear assignment to the spawning player.


if (!hasInterface) exitWith {};

fnc_BUM_Showmessage = {

    _howLongToShow = (_this select 0);

    _camera = "camera" camCreate [(getPos player select 0),(getPos player select 1),100];
    _camera cameraEffect ["internal","back"];
    _camera camSetFOV 0.700;
    _camera camCommit 0;
    waitUntil {camCommitted _camera};
    _timeLeft = "";
    if (isNil "WaveSpawn_TimeToSpawn") then {
         _timeLeft = "You have JIPed. Ask others in the wait area for the time to spawn. Stay in the wait area!";
    } else {
        _timeLeft = format ["You will respawn in: %1 minutes. Stay in the wait area!", WaveSpawn_TimeToSpawn];
    };

    cutText[_timeLeft, "BLACK FADED", 120];
    uiSleep _howLongToShow;
    player cameraEffect ["terminate","back"];
    camDestroy _camera;
    cutText["", "BLACK IN", 5];
};

waitUntil {!isNull player};

WaveSpawn_ForceMovePlayer = false;
WaveSpawn_RespawnMarker = "";
WaveSpawn_WaveRespawnMarker = "";

while {WaveSpawn_RespawnMarker == ""} do
{
    switch (side player) do {
        case west: {
            WaveSpawn_RespawnMarker = "respawn_west";
            WaveSpawn_WaveRespawnMarker = "wave_respawn_west";
        };

        case east: {
            WaveSpawn_RespawnMarker = "respawn_east";
            WaveSpawn_WaveRespawnMarker = "wave_respawn_east";
        };

        case civilian: {
            WaveSpawn_RespawnMarker = "respawn_civilian";
            WaveSpawn_WaveRespawnMarker = "wave_respawn_civilian";
        };

        case resistance: {
            WaveSpawn_RespawnMarker = "respawn_guerrila";
            WaveSpawn_WaveRespawnMarker = "wave_respawn_guerrila";
        };
    };
};



player addEventHandler ["Respawn",{

	removeAllWeapons (_this select 0);
	_this select 0 removeweapon "itemradio";

	if !(player call TFAR_fnc_backpackLR isequalTo []) Then {
		removeBackpack player;
	};

    [20] spawn fnc_BUM_Showmessage;

    [] spawn {

        WaveSpawn_ForceMovePlayer = true;
        Sleep 1;

        while {WaveSpawn_ForceMovePlayer} do {

            if (player distance (getMarkerPos WaveSpawn_RespawnMarker) > 30) Then {

                player setPos [
                random 10 - 5 + (getMarkerPos WaveSpawn_RespawnMarker select 0),
                random 10 - 5 + (getMarkerPos WaveSpawn_RespawnMarker select 1),
                0];

                [10] spawn fnc_BUM_Showmessage;
            };
            sleep 1;
        };
    };
}];

"WaveSpawn_PublicVariable" addPublicVariableEventHandler {
	if (side player == _this select 1) Then {

        WaveSpawn_ForceMovePlayer = false;
		if (player distance getMarkerPos WaveSpawn_RespawnMarker < 35) Then {  // Player near factions respawn marker teleports to wave_respawn_xxxxx marker and receives gear.

            player setPos [
            random 16 - 8 + (getMarkerPos WaveSpawn_WaveRespawnMarker select 0),
            random 16 - 8 + (getMarkerPos WaveSpawn_WaveRespawnMarker select 1),
            0];

            [] Spawn {
                    cutText["You have Respawned!", "BLACK FADED", 120];
                    uiSleep 3;
                    execVM "Wave\WaveGear.sqf";
                    uiSleep 2;
                    cutText["", "BLACK IN", 5];
            };

		};

        if (isnil "WaveSpawn_ClientTimerStarted") Then {
            WaveSpawn_ClientTimerStarted = execVM "Wave\HowLongToSpawnTimer.sqf";
        };
	};
};